#pragma once

#ifndef __RETURN_CODE_
#define __RETURN_CODE_

#define TOTAL_MESSAGE 37

///////////////////////////////////////////////////////////////////////////////////////
///////////// RETURN VALUE FROM MODULE ////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////

//COMMON
///////////////////////////////////////////////////////////////////////////////////////
#define COMMON_SYSTEM_INIT									0x77
#define COMMON_TIMEOVER										0x79
#define COMMON_VERSION_DISPLAY								0x10
#define COMMON_CANCELATION									0x14
#define COMMON_CHECKSUM_ERROR								0x9f

//registration
///////////////////////////////////////////////////////////////////////////////////////
#define REGISTRATION_SUCCESS								0xf1

#define REGISTRATION_FAIL									0x01

#define REGISTERARION_NO_IRIS_FRAME							0x21 							//err -2
#define REGISTRATION_BAD_OR_INSUFFICENT_IRIS_FRAME			0x51 							//err -5

#define REGISTRATION_MODULE_DB_OVER_FLOW					0x41 							//err -4
#define REGISTRATION_VIDEO_MODE								0xc0

//IDENTIFICATION
///////////////////////////////////////////////////////////////////////////////////////
#define IDENTIFICATION_SUCCESS								0xf2

#define	IDENTIFICATION_FAIL									0x02

#define IDENTIFICATION_NO_IRIS_FRAME						0x22							//err -2

#define IDENTIFICATION_NO_ID_IN_DB							0x32 							//err -3
#define IDENTIFICATION_NONE_IN_DB							0x31 							//err -3

//DELETION
///////////////////////////////////////////////////////////////////////////////////////
#define DELETION_SUCCESS									0xf3 
#define DELETION_FAIL										0x03 

//SAVE
///////////////////////////////////////////////////////////////////////////////////////
#define SAVE_SUCCESS										0xf5 
#define SAVE_FAIL											0x65 							//err -6

//ID LIST
#define ID_LIST_GET											0x06 

//GET IRIS TMEPLATE FROM MODULE
///////////////////////////////////////////////////////////////////////////////////////
#define GET_TEMPLATE_RETRIEVAL_START						0xb1 							//transmission
#define GET_TEMPLATE_RETRIEVAL_COMPLETE						0xb4 

//PUT IRIS TMEPLATE FROM MODULE
///////////////////////////////////////////////////////////////////////////////////////
#define PUT_TEMPLATE_FILE_ALREADY_EXIST						0xb8
#define PUT_TEMPLATE_DB_OVER_FLOW							0xb9 
#define PUT_TEMPLATE_FILE_FORMAT_ERROR						0xb5 
#define PUT_TEMPLATE_FILE_TRANSFER_READY_TO_START			0xba 

///////////////////////////////////////////////////////////////////////////////////////
///////////// DEFINED VALUE FOR USE IN DIALOG BOX /////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////

enum{
	//common
	MESSAGE_COMMON_SYSTEM_INIT,
	MESSAGE_USB_NOT_FOUND,
	MSEEAGE_USB_FOUND,
	//dialog
	MESSAGE_WELCOME,
	//id
	MESSAGE_ID_NOT_INSERTED,
	//query
	MESSAGE_DATABASE_FULL,
	MESSAGE_DATABASE_EMPTY,
	MESSAGE_TRANSMISSION,
	MESSAGE_TIME_OVER,
	MESSAGE_COMMON_CHECKSUM_ERROR,
	MESSAGE_SUCCESS_DOWNLOAD,
	MESSAGE_PUT_TEMPLATE_FILE_TRANSFER_READY_TO_START,
	MESSAGE_REGIST_CODE_DOWNLOAD,
	MESSAGE_VIDEO_registration,
	MESSAGE_ID_LENGTH_EXCEEDED,
	//db
	MESSAGE_IS_NOT_FOUND,
	MESSAGE_FILENAME_DO_NOT_EXIST,
	MESSAGE_TEMPLATE_ID_NOT_FOUND,
	//function - register
	MESSAGE_IS_REGISTERING,
	MESSAGE_IS_REGISTERED,
	MESSAGE_IS_NOT_REGISTERED,
	MESSAGE_REGI_NO_FRAME_CAPTURED,
	MESSAGE_REGI_NOT_ENOUGH_FRAME,
	//function - certificate
	MESSAGE_IS_CERTFYING,
	MESSAGE_IS_CERTIFICATED,
	MESSAGE_IS_NOT_CERTIFICATED,
	MESSAGE_CERT_NO_FRAME_CAPTURED,
	MESSAGE_CERT_NOT_ENOUGH_FRAME,
	//function - save
	MESSAGE_IS_SAVED,
	MESSAGE_IS_NOT_SAVED,
	//function - cancel	
	MESSAGE_CANCEL,
	//function - list
	MESSAGE_LIST,
	MESSAGE_LIST_DONE,
	MESSAGE_PUT_TEMPLATE_FILE_FORMAT_ERROR,
	//function - delete
	MESSAGE_DELETE_FAIL,
	MESSAGE_ALL_DELETED,
	MESSAGE_IS_DELETED,
};

extern char DialogMessageList[TOTAL_MESSAGE][256];

#endif // __RETURN_CODE_